crehana/cart/urls.py
from django.urls import path
from . import views

app_name = 'cart'
urlpatterns = [
    path('', views.get_cart, name='cart'),
    path('add/', views.add_to_cart, name='add_to_cart'),
]

crehana/config/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
                  path('admin/', admin.site.urls),
                  path('', include('cursos.urls', namespace='cursos')),
                  path('cart/', include('cart.urls', namespace='cart')),
                  path('usuarios/', include('usuarios.urls', namespace='usuarios')),
              ] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT) + \
              static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

crehana/cursos/urls.py
from django.urls import path

from . import views

app_name = 'cursos'

urlpatterns = [
    path('', views.cursos, name='lista'),
    path('curso/<str:slug>/', views.cursos, name='detalle'),
]

crehana/usuarios/urls.py
from django.urls import path
from . import views

app_name = 'cart'
urlpatterns = [
    path('registro', views.signup_view, name='registro'),
    path('ingresar/', views.login_view, name='login'),
    path('salir/', views.logout, name='salir'),
]

crehana/cart/models.py
from django.db import models
from cursos.models import Curso
from . import constants
from core.models import CreateModel


class Cart(CreateModel):
    estado = models.CharField('Estado del Pedido', max_length=2, choices=constants.CARRITO_ESTADO,
                              default=constants.ESTADO_PENDIENTE)

    class Meta:
        verbose_name = 'Pedido'
        verbose_name_plural = 'Pedidos'

    def __str__(self):
        return str(self.id)

    def precio_total(self):
        total = 0
        for item in self.item_set.all():
            total = total + item.precio
        return total


class Item(models.Model):
    cart = models.ForeignKey(Cart, verbose_name='Pedido', on_delete=models.PROTECT)
    precio = models.DecimalField(max_digits=18, decimal_places=2, verbose_name='Precio')
    id_curso = models.IntegerField('ID')

    def __str__(self):
        return '{}'.format(self.curso.__class__.__name__)

    @property
    def curso(self):
        return Curso.objects.get(id=self.id_curso)

crehana/core/models.py
from django.db import models
from uuslug import uuslug


class CreateModel(models.Model):
    created = models.DateTimeField('Fecha de creación', auto_now_add=True)

    class Meta:
        abstract = True


class SlugModel(models.Model):
    nombre = models.CharField('Nombre', max_length=120, db_index=True)
    slug = models.SlugField('slug', max_length=180, blank=True)

    class Meta:
        abstract = True

    def __str__(self):
        return self.nombre

    def save(self, *args, **kwargs):
        self.slug = uuslug(self.nombre, instance=self)
        super(SlugModel, self).save(*args, **kwargs)

crehana/cursos/models.py
from django.db import models
from django.shortcuts import reverse
from core.models import CreateModel
from core.models import SlugModel


class Curso(CreateModel, SlugModel):
    precio = models.IntegerField(default=0, help_text='Precio en soles')
    duracion = models.IntegerField(default=0, help_text='Duración en minutos')
    portada = models.ImageField(upload_to='cursos/portadas/')

    def get_absolute_url(self):
        return reverse('cursos:detalle', kwargs={'slug': self.slug})

crehana/usuarios/forms.py
from django import forms
from django.contrib.auth import authenticate
from django.contrib.auth.models import User


class LoginForm(forms.Form):
    email = forms.EmailField(label='Email')
    password = forms.CharField(label='Contraseña', min_length=8, max_length=32, widget=forms.PasswordInput)

    def clean_email(self):
        email = self.cleaned_data['email']
        try:
            User.objects.get(username=email)
        except User.DoesNotExist:
            mensaje = 'El email no ha sido registrado'
            raise forms.ValidationError(mensaje)

        return email

    def auth(self):
        cd = self.cleaned_data
        print('::'+cd['email']+'::')
        print('::'+cd['password']+'::')
        return authenticate(username=cd['email'], password=cd['password'])


class SignupForm(forms.Form):
    email = forms.EmailField(label='Email')
    password = forms.CharField(label='Contraseña', min_length=8, max_length=32, widget=forms.PasswordInput)

    def clean_email(self):
        email = self.cleaned_data['email']
        try:
            User.objects.get(username=email)
            mensaje = 'El email ya existe en nuestra base de datos'
            raise forms.ValidationError(mensaje)
        except User.DoesNotExist:
            return email

    def save(self):
        cd = self.cleaned_data
        user = User.objects.create_user(username=cd['email'], email=cd['email'], password=cd['password'],
                                        is_active=False)
        user.save()
        return user

    def auth(self):
        cd = self.cleaned_data
        return authenticate(username=cd['email'], password=cd['password'])

crehana/cart/views.py
from django.http import JsonResponse
from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from cart.cart import Cart, CART_ID
from cursos.models import Curso
from usuarios.constants import LOGIN_URL


def add_to_cart(request):
    id_curso = request.POST.get('id_curso', '').strip()
    try:
        curso = Curso.objects.get(id=id_curso)
    except:
        # en caso de errores, reiniciamos la sesión
        if CART_ID in request.session.keys():
            del request.session[CART_ID]
        return JsonResponse({
            'status': False
        })

    cart = Cart(request)
    cart.add(id_curso, curso.precio)
    response = {'status': True, 'url_redirect': '/cart/'}

    return JsonResponse(response)


@login_required(login_url=LOGIN_URL)
def get_cart(request):
    cart = Cart(request)
    dict_cart = dict(cart)

    return render(request, 'cart/carrito.html', locals())

crehana/cursos/views.py
from django.shortcuts import render
from .models import Curso


def cursos(request, slug=None):
    if slug:
        curso = Curso.objects.get(slug=slug)
        return render(request, 'cursos/curso.html', locals())

    cursos = Curso.objects.all()
    return render(request, 'cursos/cursos.html', locals())

crehana/usuarios/views.py
from django.utils import timezone
from django.shortcuts import render, redirect, reverse
from django.urls import reverse_lazy
from django.contrib.auth import login
from django.contrib.auth.views import logout_then_login
from django.contrib import messages

from .forms import SignupForm, LoginForm
from .constants import DJANGO_MODEL_BACKEND, LOGIN_URL


def logout(request):
    return logout_then_login(request, login_url=LOGIN_URL)


def signup_view(request):
    if request.method == 'POST':
        form = SignupForm(request.POST)
        if form.is_valid():
            user = form.save()

            return redirect(reverse_lazy('cart:cart'))
        else:
            errors = form.errors
    else:
        form = SignupForm()
    return render(request, 'users/registro.html', locals())


def login_view(request):
    if request.user.is_authenticated:
        return redirect('cursos:listado')

    if request.method == 'POST':
        form = LoginForm(request.POST)
        if form.is_valid():
            user = form.auth()
            if user:
                if user.is_active:
                    user.last_login = timezone.now()
                    user.save()
                    login(request, user, DJANGO_MODEL_BACKEND)

                    location = request.GET.get('next', None)

                    if location:
                        return redirect(location)

                    return redirect(reverse('cursos:lista'))
                else:
                    messages.add_message(request, messages.WARNING, 'El usuario no se encuentra activo')
            else:
                messages.add_message(request, messages.WARNING, u'El email y contraseña son inválidos')
        else:
            print('Error de formulario')
    else:
        form = LoginForm()

    return render(request, 'users/login.html', locals())

crehana/templates/cart/carrito.html
{% extends 'core/base.html' %}
{% load static %}

{% block content %}

<section>
    <h1>Carrito de compras</h1>
    <ol>
        {% for item in cart.get_items %}
            <li>{{ item.curso.nombre }} - S/ {{ item.precio }}
            </li>
        {% endfor %}
    </ol>

    <p><strong>Total:</strong> S/ {{ cart.total }}</p>
</section>
{% endblock content %}

crehana/templates/core/base.html
<!doctype html>
<html lang="es">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <title>Crehana - clon</title>
    <meta name="description" content="Desarrollado con fines educativos">
    <meta name="viewport" content="width=device-width, initial-scale=1">
</head>

<body>
{% include 'core/header.html' %}
{% include 'core/messages.html' %}
{% block content %}
{% endblock content %}

{% block js %}
{% endblock js %}
</body>
</html>

crehana/templates/core/header.html
<header>
    <nav>
        <ul>
            <li><a href="{% url 'cursos:lista' %}">Cursos</a></li>
            <li><a href="/cart/">Carrito de compras</a></li>
            {% if request.user.is_authenticated %}
                <li>{{ request.user.username }}</li>
                <li><a href="{% url 'usuarios:salir' %}">Salir</a></li>
            {% else %}
                <li><a href="{% url 'usuarios:login' %}">Ingresar</a></li>
                <li><a href="{% url 'usuarios:registro' %}">Registro</a></li>
            {% endif %}
        </ul>
    </nav>
</header>

crehana/templates/core/messages.html
{% if messages %}
<ul class="messages">
    {% for message in messages %}
    <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
    {% endfor %}
</ul>
{% endif %}

crehana/templates/cursos/curso.html
{% extends 'core/base.html' %}

{% block content %}
    <section>
        <h1>{{ curso.nombre }}</h1>

        <article>
            <a href="{{ curso.get_absolute_url }}">
                <img src="{{ curso.portada.url }}" alt="{{ curso.nombre }}" width="260" height="170">
            </a>
            <p><strong>Precio: </strong> S/ {{ curso.precio }}</p>
            <p><strong>Duración: </strong> {{ curso.duracion }} minutos</p>
        </article>
    </section>
{% endblock content %}

crehana/templates/cursos/cursos.html
{% extends 'core/base.html' %}
{% load static %}

{% block content %}
    {% for curso in cursos %}
        <section>
            <h1>Cursos</h1>

            <article>
                <h2>{{ curso.nombre }}</h2>
                <a href="{{ curso.get_absolute_url }}">
                    <img src="{{ curso.portada.url }}" alt="{{ curso.nombre }}" width="260" height="170">
                </a>
                <p><strong>Precio: </strong> S/ {{ curso.precio }}</p>
                <p><strong>Duración: </strong> {{ curso.duracion }} minutos</p>

                <button class='btnAdd' data-id='{{ curso.id }}'>Agregar al carrito</button>
            </article>
        </section>
    {% endfor %}
{% endblock content %}

{% block js %}
    <script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
    <script src="{% static 'js/utils.js' %}"></script>

    <script>
        $('.btnAdd').click(function () {
            var id_curso = $(this).attr('data-id');

            $.ajax({
                url: "/cart/add/",
                type: "POST",
                data: {
                    id_curso: id_curso
                },
                success: function (result) {
                    window.location.href = '/cart/';
                }
            });
        })
    </script>
{% endblock js %}

crehana/templates/users/login.html
{% extends 'core/base.html' %}

{% block content %}
    <section>
        <h1>Ingresar</h1>

        <form action="#" method="POST">
            {% csrf_token %}
            {{ form.as_ul }}
            {{ form.errors }}
            <input type="submit">
        </form>
    </section>
{% endblock content %}

crehana/templates/users/registro.html
{% extends 'core/base.html' %}

{% block content %}
    <section>
        <h1>Registrarse</h1>

        <form action="#" method="POST">
            {% csrf_token %}
            {{ form.as_ul }}
            <input type="submit">
        </form>
    </section>
{% endblock content %}